/***************************************************************************
    begin       : Wed Jun 16 2010
    copyright   : (C) 2010 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef RSCT_NET_NETWORK_H
#define RSCT_NET_NETWORK_H


#include "message.h"


#ifdef __cplusplus
extern "C" {
#endif


int rsct_net_listen_by_ip(const char *ip, int port);
int rsct_net_listen_by_path(const char *name);

int rsct_net_accept(int sk);

int rsct_net_connect_by_ip(const char *ip, int port);
int rsct_net_connect_by_path(const char *name);

int rsct_net_recv(int sk, RSCT_MESSAGE *msg);
int rsct_net_send(int sk, const RSCT_MESSAGE *msg);


#ifdef __cplusplus
}
#endif


#endif




